var LibQC = function()
{
	var libqc = {};
	var debug = 0;
	
	var bioplateIsValid = false;
	var qcCommentsIsValid = false;

	// Page initialization
	libqc.initPage = function()
	{
		// Step 1
		Events.addEventHandler('bioplate', 'change', libqc.bioplateOnChange);
		Events.addEventHandler('step-1', 'wizard-validate', libqc.validateStep1);
		Buttons.addClickHandler('btnSelectLibPlate', libqc.selectLibPlate);
		Events.addEventHandler('bioplate', 'base-selected', libqc.libPlateSelected);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', libqc.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', libqc.validateStep2);
		Events.addEventHandler('qcDate', 'blur', Wizard.validateDate);
		Events.addEventHandler('qccomments', 'blur',libqc.commentsOnChange);
		Wizard.initFileSelectionField('pdfqc');

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', libqc.submit);
		
		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=GetLibraryPlatesForLibPrep';
		Wizard.showLoadingAnimation('Loading Library plates...');
		Wizard.asyncJsonRequest(url, libqc.initializeStep1);
	}


	libqc.initializeStep1 = function(response)
	{
		var frm = document.forms['reggie'];
		var bioplates = response.bioplates;

		var plates = frm.bioplate;
		if (bioplates.length > 0)
		{
			for (var i=0; i < bioplates.length; i++)
			{
				var bioplate = bioplates[i];
				var option = new Option(bioplate.name, bioplate.id);
				option.plate = bioplate;
				plates.options[plates.length] = option;
			}
		}

		frm.bioplate.focus();
		libqc.bioPlateOnChange();

		Doc.show('step-1');
		Doc.show('gonext');
	}
	
	libqc.bioPlateOnChange = function()
	{
		var frm = document.forms['reggie'];
		bioplateIsValid = false;

		if (frm.bioplate.length == 0)
		{
			Wizard.setInputStatus('bioplate', 'invalid', 'No Library plate available for processing.');
			return;
		}
		
		bioplateIsValid = true;
		Wizard.setInputStatus('bioplate', 'valid');
	}

	libqc.selectLibPlate = function()
	{
		var frm = document.forms['reggie'];
		if (frm.bioplate.disabled) return;
		
		var url = '&resetTemporary=1';
		url += '&tmpfilter:STRING:bioPlateType.name=Library+plate';
		Dialogs.selectItem('BIOPLATE', 'bioplate', 0, url);
	}
	
	
	libqc.libPlateSelected = function(event)
	{
		var id = event.detail.id;
		var name = event.detail.name;
		
		var frm = document.forms['reggie'];
		var plateList = frm.bioplate;
		for (var i = 0; i < plateList.length; i++)
		{
			if (plateList[i].value == id)
			{
				plateList[i].selected = true;
				libqc.bioPlateOnChange();
				return;
			}
		}
		
		var option = new Option(name, id, true, true);
		plateList[plateList.length] = option;
		libqc.bioPlateOnChange();
	}


	libqc.validateStep1 = function(event)
	{
		if (!bioplateIsValid) event.preventDefault();		
	}
	
	libqc.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];	
		Wizard.setCurrentStep(2);
		Doc.show('goregister');
		Doc.show('gocancel');
		Events.sendChangeEvent('pdfqc');
		libqc.commentsOnChange();
		frm.qcDate.focus();
	}

	libqc.commentsOnChange = function()
	{
		var frm = document.forms['reggie'];
		qcCommentsIsValid = false;
		Wizard.setInputStatus('qccomments');
		
		var comments = frm.qccomments.value;
		if (comments == '')
		{
			Wizard.setInputStatus('qccomments', 'invalid', 'Missing');
			return;
		}

		Wizard.setInputStatus('qccomments', 'valid');
		qcCommentsIsValid = true;
	}

	libqc.validateStep2 = function(event)
	{
		var valid = qcCommentsIsValid;
		valid &= Wizard.isValid('pdfqc');
		valid &= Wizard.isValid('qcDate');
		
		if (!valid) 
		{
			event.preventDefault();
		}
	}
	
	libqc.submit = function()
	{
		var frm = document.forms['reggie'];

		var submitInfo = {};
		submitInfo.bioplate = parseInt(frm.bioplate.value, 10);
		submitInfo.qcDate = frm.qcDate.value;
		submitInfo.qcPdf = frm.pdfqc.value;
		submitInfo.qcComments = frm.qccomments.value;

		var url = '../LibPrep.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportLibPrepQcResults';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, libqc.submissionResults, 'POST', JSON.stringify(submitInfo));
	}

	libqc.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return libqc;
}();

Doc.onLoad(LibQC.initPage);

